import { ConsoleLogger, Injectable } from '@nestjs/common';
import { UseEvent } from 'koishi-nestjs';
import { Session } from 'koishi';

@Injectable()
export class OnSubscribeService extends ConsoleLogger {
  constructor() {
    super('OnSubscribeService');
  }
  @UseEvent('wechat:subscribe')
  async onSubscribe(session: Session) {
    this.log(`User ${session.userId} subscribed.`);
    await session.send(
      '欢迎关注决斗暗网！\n' +
        '\n' +
        '我们的菜单包含了各种功能，其中有游戏下载方式，玩家社区，举报反馈渠道等。',
    );
  }

  @UseEvent('wechat:unsubscribe')
  async onUnsubscribe(session: Session) {
    this.log(`User ${session.userId} unsubscribed.`);
  }
}
