import { Injectable, OnModuleInit } from '@nestjs/common';
import { InjectContext } from 'koishi-nestjs';
import { Context } from 'koishi';

@Injectable()
export class ReplyService implements OnModuleInit {
  replies: { key: string; content: string }[] = [
    {
      key: 'download',
      content:
        '"下列都为游戏王YGOPro在各平台的软件，名字不同，但本质一样。MyCard平台会提供YGOPro和YGOPro2的下载与对战。\n' +
        '安卓端YGOMobile下载：https://ygomobile.topIOS\n' +
        '苹果端KoishiPro iOS下载：https://koishi.pro/download/\n' +
        '电脑端（包含Win和Mac）MyCard萌卡平台下载：https://mycard.moe"',
    },
    {
      key: 'servers',
      content:
        '1. MyCard服。电脑用户请使用MyCard客户端，安卓端用户点击【萌卡平台】，IOS端用户点击【MyCard】\n' +
        '2. 233服。主机信息：s1.ygo233.com  端口：233。端口改为23333为先行卡服。\n' +
        '3. Koishi服。主机信息：koishi.momobako.com 端口：7210。该服拥有断线重连。\n' +
        '4. 轮抽2pick服。轮抽娱乐模式的服务器。 详情 https://ygobbs.com/t/87931\n' +
        '5. 分级服。靠特殊卡表限制主流进场的服务器。详情 https://ygobbs.com/t/364147\n' +
        '6. 游戏王Rush Duel服。遵循游戏王Rush Duel规则的服务器。详情 https://ygobbs.com/t/200563\n' +
        '7. 高速决斗服。人物技能+游戏王5DS高速决斗模式。 详情 https://ygobbs.com/t/166971\n' +
        '8. 诡异空间服。平衡的独立卡池，特殊规则服。详情 https://ygobbs.com/t/303983',
    },
    {
      key: 'update',
      content:
        '安卓端YGOMobile：登录后会提示更新，手动更新请访问https://ygomobile.top\n' +
        '苹果端KoishiPro2 iOS：用电脑使用爱思助手自签更新，教程请见 https://koishi.pro/download/\n' +
        '电脑端MyCard会自动更新。若自动更新没触发，请在游戏大厅下方点击【校验完整性】更新。',
    },
    {
      key: 'faq',
      content:
        '如果遇到了游戏安装、出BUG、下载等问题，请访问 https://ygobbs.com/t/108594\n' +
        '如果遇到了游戏处理，规则类问题，请查看游戏王OCG规则修订书 https://ocg-rule.readthedocs.io/zh_CN/latest/ \n' +
        '\n' +
        '其他寻求帮助的方式：\n' +
        '1. 在 ygobbs.com 搜索符合您问题描述的帖子，95%以上问题都有其他用户发帖询问过。\n' +
        '2. 若没有，您可以在MC玩家社区 ygobbs.com 带上恰当的描述发帖寻求帮助，管理员会在36小时内回帖。\n' +
        '3. 若问题很复杂，请加萌卡测试与 bug 反馈QQ群 553241437 询问。',
    },
    {
      key: 'novelai',
      content:
        '由于AI绘图的普及，MC与各爱好贡献者们合作成立了YGOPro卡图娘化项目。\n' +
        '现在为广大玩家们提供娘化补丁下载。\n' +
        '详情与下载方式：https://ygobbs.com/t/396440',
    },
  ];

  constructor(@InjectContext() private ctx: Context) {}
  onModuleInit() {
    const base = this.ctx.command('reply', '默认回复。');
    for (const reply of this.replies) {
      base.subcommand(`.${reply.key}`).action(() => reply.content);
    }
  }
}
